<template>
    <div v-if="innerValueCurrentPro">
        <v-card elevation="1" class="admin-content pa-4">
            <v-btn
                color="primary"
                @click="$router.go(-1)"
                class="mb-4"
            >
                <v-icon left>mdi-keyboard-backspace</v-icon>
                Retour
            </v-btn>
            <v-snackbar
                v-model="proDetailSnackbar"
                :timeout="3000"
                :color="snackbarColor"
            >
                {{snackbarMessage}}
                <template v-slot:action="{ attrs }">
                    <v-btn
                        color="white"
                        text
                        v-bind="attrs"
                        @click="proDetailSnackbar = false"
                    >
                        Fermer
                    </v-btn>
                </template>
            </v-snackbar>
            <div class="text-h4">Détail professionnel</div>
            <v-form
                ref="form"
                v-model="isFormValid"
                @submit.prevent="submitUpdatedForm"
            >
                <div class="text-h6 mt-6">Informations générales</div>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.firstName"
                            :rules="[$utils.rules.required]"
                            :counter="32"
                            label="Nom"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.lastName"
                            :rules="[$utils.rules.required]"
                            :counter="64"
                            label="Prénom"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-select
                            v-model="innerValueCurrentPro.gender"
                            :items="genderSelectItems"
                            label="Gendre"
                        ></v-select>
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.job"
                            label="Job"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.phoneNumber"
                            :rules="[$utils.rules.required]"
                            :counter="64"
                            label="Numéro de téléphone"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.email"
                            :rules="[$utils.rules.required]"
                            label="E-mail"
                            :counter="64"
                            required
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12" sm="4">
                        <v-select
                            v-model="innerValueCurrentPro.enabled"
                            :items="enabledSelectItems"
                            label="Statut"
                        ></v-select>
                    </v-col>
                    <v-col cols="12" sm="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.dob"
                            type="date"
                            label="Date de naissance"
                        ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.createdAt"
                            label="Date de création"
                            disabled
                        />
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12">
                        <v-textarea
                            v-model="innerValueCurrentPro.description"
                            label="Description"
                            clearable
                            color="teal"
                        />
                    </v-col>
                </v-row>
                <div class="text-h6 mt-6">Adresse complète</div>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.address"
                            :rules="[$utils.rules.required]"
                            :counter="64"
                            label="Adresse"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.city"
                            :rules="[$utils.rules.required]"
                            label="Ville"
                            :counter="64"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.postalCode"
                            :rules="[$utils.rules.required]"
                            label="Code postale"
                            :counter="8"
                            required
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentPro.country"
                            :rules="[$utils.rules.required]"
                            label="Pays"
                            :counter="64"
                            required
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-btn color="green" type="submit" dark :disabled="!isFormValid">
                    Enregistrer
                </v-btn>
            </v-form>
        </v-card>
        <Offices :title="`Cabinets de ${innerValueCurrentPro.firstName}`" :officesOfPro="innerValueCurrentPro.offices" />
        <v-card elevation="1" class="admin-content pa-4">
          <div class="text-h5 mb-4">Débug</div>
          <p>{{ JSON.stringify(innerValueCurrentPro) }}</p>
        </v-card>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';
import Offices from '@/views/Admin/Office/Offices';
import moment from 'moment';

export default {
    name: 'ProDetail',
    components: {
        Offices
    },
    data: () => ({
        innerValueCurrentPro: null,
        isFormValid: true,
        proDetailSnackbar: false,
        snackbarColor: '',
        snackbarMessage: '',
        enabledSelectItems: [
            {text: 'Vérifié', value: 1},
            {text: 'En attente', value: 0}
        ],
        genderSelectItems: [
            {text: 'Homme', value: 'men'},
            {text: 'Femme', value: 'women'},
            {text: 'Autre', value: 'other'}
        ],
    }),
    methods: {
        ...mapActions(['loadPro', 'updatePro']),
        submitUpdatedForm() {
            let dataChanged = this.$utils.getChanges(this.getCurrentPro, this.innerValueCurrentPro);
            if (!this.$utils.isEmptyObject(dataChanged)) {
                dataChanged.id = this.innerValueCurrentPro.id;
                this.updatePro(dataChanged)
                    .then(() => {
                        this.snackbarColor = 'green';
                        this.snackbarMessage = 'Les données ont été sauvegardées';
                        this.proDetailSnackbar = true;
                    })
                    .catch(() => {
                        this.snackbarColor = 'red';
                        this.snackbarMessage = this.getCrudError;
                        this.proDetailSnackbar = true;
                    });
            } else {
                this.snackbarColor = 'green';
                this.snackbarMessage = 'Les données ont été sauvegardées';
                this.proDetailSnackbar = true;
            }
        }
    },
    computed: {
        ...mapGetters(['getCurrentPro'])
    },
    async mounted() {
        await this.loadPro(this.$route.params.proId);
        this.innerValueCurrentPro = Object.assign({}, this.getCurrentPro);
        this.innerValueCurrentPro.createdAt = moment(this.innerValueCurrentPro.createdAt).format('YYYY-MM-DD');
        this.innerValueCurrentPro.dob = moment(this.innerValueCurrentPro.dob).format('YYYY-MM-DD');
    }
}
</script>

